DROP TABLE IF EXISTS transactions;

CREATE TABLE transactions (
  txId       INT            NOT NULL AUTO_INCREMENT PRIMARY KEY,
  payeeId    INT            NOT NULL,
  amount     DECIMAL(20, 2) NOT NULL,
  txType     VARCHAR(50)    NOT NULL,
  txStatus   VARCHAR(50)    NOT NULL,
  txDate     TIMESTAMP      NOT NULL,
  accountId  INT            NOT NULL,
  categoryId INT            NOT NULL
);

DROP TABLE IF EXISTS payees;

CREATE TABLE payees (
  payeeId    INT          NOT NULL AUTO_INCREMENT PRIMARY KEY,
  payee      VARCHAR(255) NOT NULL,
  categoryId INT          NOT NULL,
  address    VARCHAR(255) NOT NULL,
  city       VARCHAR(255) NOT NULL,
  state      VARCHAR(50)  NOT NULL,
  zip        VARCHAR(25)  NOT NULL,
  image      VARCHAR(255),
  motto      VARCHAR(512)
);

DROP TABLE IF EXISTS categories;

CREATE TABLE categories (
  categoryId   INT NOT NULL AUTO_INCREMENT PRIMARY KEY,
  categoryName VARCHAR(255)
);

DROP TABLE IF EXISTS accounts;

CREATE TABLE accounts (
  accountName   VARCHAR(255)   NOT NULL,
  accountId     INT            NOT NULL AUTO_INCREMENT PRIMARY KEY,
  accountType   INT            NOT NULL,
  accountNumber INT            NOT NULL,
  currentTotal  DECIMAL(20, 2) NOT NULL
);
