package com.speedingplanet.banking.db;

import com.speedingplanet.banking.api.Payee;
import io.dropwizard.hibernate.AbstractDAO;
import org.hibernate.Criteria;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Restrictions;

import javax.ws.rs.core.MultivaluedMap;
import java.util.List;

public class PayeeDAO extends AbstractDAO<Payee> {

  public PayeeDAO(SessionFactory sessionFactory) {
    super(sessionFactory);
  }

  public Payee findById(Integer id) {
    return get(id);
  }

  public List<Payee> findAll() {
    return list(namedQuery("com.speedingplanet.banking.api.Payee.findAll"));
  }

  public List<Payee> query(MultivaluedMap<String, String> queryParams) {
    Criteria c = criteria();

    // Assumes, for the moment, that keys are singular, not multiples
    for (String key : queryParams.keySet()) {
      if (key.equals("payeeId") || key.equals("categoryId")) {
        c.add(Restrictions.eq(key, Integer.parseInt(queryParams.getFirst(key))));
      } else {
        c.add(Restrictions.eq(key, queryParams.getFirst(key)));
      }
    }

    return list(c);
  }

}
