package com.speedingplanet.banking.api;

import com.fasterxml.jackson.databind.ObjectMapper;
import io.dropwizard.jackson.Jackson;
import org.joda.time.DateTime;
import org.junit.Test;

import static io.dropwizard.testing.FixtureHelpers.fixture;
import static org.assertj.core.api.Assertions.assertThat;

public class TransactionTest {
  private static final ObjectMapper MAPPER = Jackson.newObjectMapper();

  @Test
  public void serializesToJSON() throws Exception {
    final Transaction tx = new Transaction(1,
        8,
        1,
        "Debit",
        17,
        "Cleared",
        new DateTime("2015-01-04T23:50:19.938-0000"), // Need tz info because otherwise it's EST and fails
        -97.74
    );

    final String expected = MAPPER.writeValueAsString(MAPPER.readValue(fixture("fixtures/transaction.json"), Transaction.class));
    assertThat(MAPPER.writeValueAsString(tx)).isEqualTo(expected);
  }

  @Test
  public void deserializesFromJSON() throws Exception {
    final Transaction tx = new Transaction(1,
        8,
        1,
        "Debit",
        17,
        "Cleared",
        new DateTime("2015-01-04T23:50:19.938-0000"), // Need tz info because otherwise it's EST and fails
        -97.74
    );

    assertThat(MAPPER.readValue(fixture("fixtures/transaction.json"), Transaction.class)).isEqualTo(tx);

  }
}
