package com.speedingplanet.equities.api;

import javax.persistence.*;
import javax.validation.constraints.NotNull;

@Entity
@Table(name = "securities")
@NamedQueries({
    @NamedQuery(
        name = "com.speedingplanet.equities.api.Security.findAll",
        query = "SELECT sec from Security sec"
    )
})
public class Security {

  @Id
  private String symbol;

  @NotNull
  private String securityName;

  public Security() {
  }

  public Security(String symbol, String securityName) {
    this.symbol = symbol;
    this.securityName = securityName;
  }

  public String getSecurityName() {
    return this.securityName;
  }

  public String getSymbol() {
    return this.symbol;
  }

  @Override
  public boolean equals(Object o) {
    if (this == o) return true;
    if (!(o instanceof Security)) return false;

    Security security = (Security) o;

    if (!getSymbol().equals(security.getSymbol())) return false;
    return securityName.equals(security.securityName);

  }

  @Override
  public int hashCode() {
    int result = getSymbol().hashCode();
    result = 31 * result + securityName.hashCode();
    return result;
  }
}
