DROP TABLE IF EXISTS securities;

CREATE TABLE securities (
  symbol       VARCHAR(10) PRIMARY KEY,
  securityName VARCHAR(255) NOT NULL,
);

DROP TABLE IF EXISTS prices;

CREATE TABLE prices (
  priceId       BIGINT PRIMARY KEY AUTO_INCREMENT,
  symbol        VARCHAR(10)    NOT NULL,
  priceDate     DATE           NOT NULL,
  open          DECIMAL(10, 6) NOT NULL,
  high          DECIMAL(10, 6) NOT NULL,
  low           DECIMAL(10, 6) NOT NULL,
  close         DECIMAL(10, 6) NOT NULL,
  volume        INT            NOT NULL,
  adjustedClose DECIMAL(10, 6) NOT NULL
);

DROP TABLE IF EXISTS positions;

CREATE TABLE positions (
  positionId  INT PRIMARY KEY         AUTO_INCREMENT,
  symbol      VARCHAR(10)    NOT NULL,
  quantity    INT            NOT NULL,
  boughtPrice DECIMAL(10, 6) NOT NULL,
  boughtDate  DATE           NOT NULL,
  soldPrice   DECIMAL(10, 6),
  soldDate    DATE,
  isActive    BOOLEAN        NOT NULL DEFAULT TRUE
);

DROP TABLE IF EXISTS orders;

CREATE TABLE orders (
  orderId   INT PRIMARY KEY AUTO_INCREMENT,
  orderDate DATE           NOT NULL,
  symbol    VARCHAR(10)    NOT NULL,
  quantity  INT            NOT NULL,
  price     DECIMAL(10, 6) NOT NULL
);