package com.speedingplanet.equities.db;

import com.speedingplanet.equities.api.Security;
import io.dropwizard.hibernate.AbstractDAO;
import org.hibernate.SessionFactory;

import java.util.List;

public class SecurityDAO extends AbstractDAO<Security> {
  public SecurityDAO(SessionFactory sessionFactory) {
    super(sessionFactory);
  }

  public Security findBySymbol(String symbol) {
    return get(symbol);
  }

  public List<Security> findAll() {
    return list(namedQuery("com.speedingplanet.equities.api.Security.findAll"));
  }

  public Security create(Security sec) {
    return persist(sec);
  }

  public Security update(Security security) {
    return persist(security);
  }

}
