package com.speedingplanet.equities;

import com.speedingplanet.equities.api.Position;
import io.dropwizard.client.JerseyClientBuilder;
import io.dropwizard.testing.ResourceHelpers;
import io.dropwizard.testing.junit.DropwizardAppRule;
import org.junit.After;
import org.junit.Before;
import org.junit.Rule;
import org.junit.Test;

import javax.ws.rs.client.Client;
import javax.ws.rs.client.WebTarget;
import javax.ws.rs.core.Response;

import static org.assertj.core.api.Assertions.assertThat;

public class PositionIntegrationTest {  private WebTarget baseTarget;
  private Client client;

  // Multiple tests (below) means that this should be a Rule, not a ClassRule
  // per https://github.com/dropwizard/dropwizard/issues/832
  @Rule
  public final DropwizardAppRule<StocksConfiguration> RULE =
      new DropwizardAppRule<>(StocksApplication.class, ResourceHelpers.resourceFilePath("test-config.yml"));

  @Before
  public void setup() {
    client = new JerseyClientBuilder(RULE.getEnvironment()).build("test client");
    baseTarget = client.target(String.format("http://localhost:%d/equities", RULE.getLocalPort()));
  }

  @After
  public void shutdown() {
    client.close();
  }

  @Test
  public void checkGetOnePos() {
    Response response = baseTarget.path("position/1").request().get();

    assertThat(response.getStatus()).isEqualTo(200);
    assertThat(response.readEntity(Position.class).getPositionId()).isEqualTo(1);
  }

}
