package com.speedingplanet.equities.api;

import com.fasterxml.jackson.databind.ObjectMapper;
import io.dropwizard.jackson.Jackson;
import org.junit.Before;
import org.junit.Test;

import java.io.IOException;

import static io.dropwizard.testing.FixtureHelpers.fixture;
import static org.assertj.core.api.Assertions.assertThat;


public class SecurityTest {
  private static final ObjectMapper MAPPER = Jackson.newObjectMapper();

  private Security security;
  private Security readSecurity;

  @Before
  public void setup() throws IOException {
    security = new Security("SEAS", "Setec Astronomy");
    readSecurity = MAPPER.readValue(fixture("fixtures/security.json"), Security.class);
  }

  @Test
  public void serializesToJSON() throws Exception {
    final String expected = MAPPER.writeValueAsString(readSecurity);
    assertThat(MAPPER.writeValueAsString(security)).isEqualTo(expected);
  }

  @Test
  public void deserializesFromJSON() {
    assertThat(readSecurity).isEqualTo(security);
  }
}
